/*
 SignaturePad: A jQuery plugin for assisting in the creation of an HTML5 canvas
 based signature pad. Records the drawn signature in JSON for later regeneration.

 Dependencies: flashcanvas, json2, jquery-1.3.2+

 @project ca.thomasjbradley.applications.signaturepad
 @author Thomas J Bradley <hey@thomasjbradley.ca>
 @link http://thomasjbradley.ca/lab/signature-pad
 @link http://github.com/thomasjbradley/signature-pad
 @copyright Copyright MMXI, Thomas J Bradley
 @license New BSD License
 @version 2.0.0
*/
(function(a){function A(l,p){function r(){a(b.typed,c).hide();q();g.bind("mousedown.signaturepad",function(d){t(d,this)});g.bind("mouseup.signaturepad",function(){o()});g.bind("mouseleave.signaturepad",function(){n||(n=setTimeout(function(){o();clearTimeout(n);n=false},200))});typeof this.ontouchstart!="undefined"&&g.each(function(){this.ontouchstart=function(d){d.preventDefault();t(d,this)};this.ontouchend=function(){o()};this.ontouchcancel=function(){o()}});a(b.clear,c).bind("click.signaturepad",
function(){q();return false});a(b.typeIt,c).bind("click.signaturepad",function(){u();return false});a(b.drawIt,c).unbind("click.signaturepad");a(b.drawIt,c).bind("click.signaturepad",function(){return false});a(b.typeIt,c).removeClass(b.currentClass);a(b.drawIt,c).addClass(b.currentClass);a(b.sig,c).addClass(b.currentClass);a(b.typeItDesc,c).hide();a(b.drawItDesc,c).show();a(b.clear,c).show()}function u(){q();g.unbind("mousedown.signaturepad");g.unbind("mouseup.signaturepad");g.unbind("mousemove.signaturepad");
g.unbind("mouseleave.signaturepad");a(b.clear,c).unbind("click.signaturepad");a(b.typed,c).show();a(b.drawIt,c).bind("click.signaturepad",function(){r();return false});a(b.typeIt,c).unbind("click.signaturepad");a(b.typeIt,c).bind("click.signaturepad",function(){return false});a(b.output,c).val("");a(b.drawIt,c).removeClass(b.currentClass);a(b.typeIt,c).addClass(b.currentClass);a(b.sig,c).removeClass(b.currentClass);a(b.drawItDesc,c).hide();a(b.clear,c).hide();a(b.typeItDesc,c).show()}function v(d){for(a(b.typed,
c).html(d.replace(/>/g,"&gt;").replace(/</g,"&lt;"));a(b.typed,c).width()>i.width;){d=a(b.typed,c).css("font-size").replace(/px/,"");a(b.typed,c).css("font-size",d-1+"px")}}function t(){g.bind("mousemove.signaturepad",function(d){w(d,this)});typeof this.ontouchstart!="undefined"&&g.each(function(){this.ontouchmove=function(d){var e,j;j=a(document).scrollTop();e=0;var m,s,x;if(j>0){m=this.offsetTop-a(this).offset().top;a(document).scrollTop(0);e=this.offsetTop-a(this).offset().top;a(document).scrollTop(j)}j=
a(document).scrollLeft();s=0;if(j>0){x=this.offsetLeft-a(this).offset().left;a(document).scrollLeft(0);s=this.offsetLeft-a(this).offset().left;a(document).scrollLeft(j)}e={top:m!=e?a(document).scrollTop():0,left:x!=s?a(document).scrollLeft():0};w(d,this,e)}})}function o(){g.unbind("mousemove.signaturepad");typeof this.ontouchstart!="undefined"&&g.each(function(){this.ontouchmove=null});h.x=null;h.y=null;k.length>0&&a(b.output,c).val(JSON.stringify(k))}function w(d,e,j){var m=a(e).offset();clearTimeout(n);
n=false;if(typeof d.changedTouches!="undefined"){e=Math.floor(d.changedTouches[0].pageX-m.left+j.left);d=Math.floor(d.changedTouches[0].pageY-m.top+j.top)}else{e=Math.floor(d.pageX-m.left);d=Math.floor(d.pageY-m.top)}if(h.x===null)h.x=e;if(h.y===null)h.y=d;f.beginPath();f.moveTo(h.x,h.y);f.lineTo(e,d);f.lineCap=b.penCap;f.stroke();f.closePath();k.push({lx:e,ly:d,mx:h.x,my:h.y});h.x=e;h.y=d}function q(){o();f.clearRect(0,0,i.width,i.height);if(!b.displayOnly){f.beginPath();f.lineWidth=b.lineWidth;
f.strokeStyle=b.lineColour;f.moveTo(b.lineMargin,b.lineTop);f.lineTo(i.width-b.lineMargin,b.lineTop);f.stroke();f.closePath()}f.lineWidth=b.penWidth;f.strokeStyle=b.penColour;a(b.output,c).val("");k=[]}function y(){var d=true;a("p."+b.errorClass,c).remove();c.removeClass(b.errorClass);a("input, label",c).removeClass(b.errorClass);if(b.drawOnly&&k.length<1){a(l).prepend('<p class="'+b.errorClass+'">'+b.errorMessageDraw+"</p>");d=false}if(a(b.name,c).val()===""){a(l).prepend('<p class="'+b.errorClass+
'">'+b.errorMessage+"</p>");a(b.name,c).focus();a(b.name,c).addClass(b.errorClass);a("label[for="+a(b.name).attr("id")+"]",c).addClass(b.errorClass);d=false}return d}var z=this,b=a.extend({},a.fn.signaturePad.defaults,p),c=a(l),g=a(b.canvas,c),i=g.get(0),f=null,h={x:null,y:null},k=[],n=false;a(b.typed,c).bind("selectstart.signaturepad",function(d){return a(d.target).is(":input")});g.bind("selectstart.signaturepad",function(d){return a(d.target).is(":input")});i.getContext||FlashCanvas.initElement(i);
if(i.getContext){f=i.getContext("2d");a(b.sig,c).show();if(!b.displayOnly){if(!b.drawOnly){a(b.name,c).bind("keyup.signaturepad",function(){v(a(this).val())});a(b.name,c).bind("blur.signaturepad",function(){v(a(this).val())});a(b.drawIt,c).bind("click.signaturepad",function(){r();return false})}b.drawOnly||b.defaultAction=="drawIt"?r():u();if(b.validateFields)a(l).is("form")?a(l).bind("submit.signaturepad",function(){return y()}):a(l).parents("form").bind("submit.signaturepad",function(){return y()});
a(b.typeItDesc,c).show();a(b.sigNav,c).show()}}a.extend(z,{regenerate:function(d){z.clearCanvas();a(b.typed,c).hide();if(typeof d==="string")d=JSON.parse(d);for(var e in d)if(typeof d[e]==="object"){f.beginPath();f.moveTo(d[e].mx,d[e].my);f.lineTo(d[e].lx,d[e].ly);f.stroke();k.push({lx:d[e].lx,ly:d[e].ly,mx:d[e].mx,my:d[e].my})}a(b.output,c).length>0&&a(b.output,c).val(JSON.stringify(k))},clearCanvas:function(){q()},getSignature:function(){return k},getSignatureString:function(){return JSON.stringify(k)},
getSignatureImage:function(){return i.toDataURL()}})}a.fn.signaturePad=function(l){var p=null;this.each(function(){p=new A(this,l)});return p};a.fn.signaturePad.defaults={defaultAction:"typeIt",displayOnly:false,drawOnly:false,canvas:"canvas",sig:".sig",sigNav:".sigNav",bgColour:"#fff",penColour:"#145394",penWidth:2,penCap:"round",lineColour:"#ccc",lineWidth:2,lineMargin:5,lineTop:35,name:".name",typed:".typed",clear:".clearButton",typeIt:".typeIt a",drawIt:".drawIt a",typeItDesc:".typeItDesc",drawItDesc:".drawItDesc",
output:".output",currentClass:"current",validateFields:true,errorClass:"error",errorMessage:"Please enter your name",errorMessageDraw:"Please sign the document"}})(jQuery);
